Skip to content

Service Edge Query.

POST
/api/data/namespaces/{namespace}/graph/service/edge
curl --request POST \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/data/namespaces/example/graph/service/edge \
--header 'Authorization: <Authorization>' \
--header 'Content-Type: application/json' \
--data '{ "dst_id": { "app_type": "example", "service": "example", "site": "example", "vip": "example", "virtual_host": "example" }, "end_time": "example", "field_selector": { "api_endpoint": {}, "healthscore": { "types": [ "HEALTHSCORE_NONE" ] }, "metric": { "features": [ "TIMESERIES_FEATURE_NONE" ], "types": [ "METRIC_TYPE_NONE" ] } }, "namespace": "example", "range": "example", "src_id": { "app_type": "example", "service": "example", "site": "example", "vip": "example", "virtual_host": "example" }, "start_time": "example", "step": "example" }'

Request to GET time-series data for an edge in the service mesh graph.

namespace
required
string

Namespace namespace is used to scope the application traffic to a given namespace.

Media typeapplication/json
Service Edge Request

While graph/service API is used to GET the service mesh for an app_type, where each node and edge contains the aggregated value for each field; graph/service/edge API is used to GET the time-series data (drill-down of aggregated data) for each field.

object
dst_id
object
app_type
App Type

Application type associated with the service.

string
<= 1024 characters
service
Service

Network name or name of the virtual service Required: YES.

string
<= 1024 characters
site
Site

Site name where the service is running. If the service is deployed in multiple sites, only the metric from this site will be returned in the response.

string
<= 1024 characters
vip
VIP

VIP associated with the Virtual Host.

string
<= 1024 characters
virtual_host
Virtual Host

Virtual host associated with the service Required: YES.

string
<= 1024 characters
end_time
End time

End time of metric collection from which data will be considered to build graph. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the end_time will be evaluated to start_time+10m If start_time is not specified, then the end_time will be evaluated to

string
<= 1024 characters
field_selector
object
api_endpoint
object
healthscore
object
types
Types

Healthscore types to be returned in the response.

Array<string>
Allowed values: HEALTHSCORE_NONE HEALTHSCORE_CONNECTIVITY HEALTHSCORE_PERFORMANCE HEALTHSCORE_SECURITY HEALTHSCORE_RELIABILITY HEALTHSCORE_OVERALL
metric
object
features
Features

Specify list of timeseries features that should be returned for each metric type in the request.

Array<string>
Allowed values: TIMESERIES_FEATURE_NONE CONFIDENCE_INTERVAL ANOMALY_DETECTION TREND HEALTHSCORE
types
Types

Specify list of metrics that should be returned for each edge in the connectivity graph.

Array<string>
Allowed values: METRIC_TYPE_NONE REQUEST_RATE ERROR_RATE RESPONSE_LATENCY REQUEST_THROUGHPUT RESPONSE_THROUGHPUT ERROR_RATE_3XX ERROR_RATE_4XX ERROR_RATE_5XX RESPONSE_LATENCY_PERCENTILE_50 RESPONSE_LATENCY_PERCENTILE_90 RESPONSE_LATENCY_PERCENTILE_99 RESPONSE_DATA_TRANSFER_DURATION CLIENT_RTT SERVER_RTT SERVER_DATA_TRANSFER_TIME APP_LATENCY REQUEST_TO_ORIGIN_RATE HTTP_REQUEST_RATE HTTP_ERROR_RATE HTTP_ERROR_RATE_4XX HTTP_ERROR_RATE_5XX HTTP_RESPONSE_LATENCY HTTP_RESPONSE_LATENCY_PERCENTILE_50 HTTP_RESPONSE_LATENCY_PERCENTILE_90 HTTP_RESPONSE_LATENCY_PERCENTILE_99 HTTP_SERVER_DATA_TRANSFER_TIME HTTP_APP_LATENCY TCP_CONNECTION_RATE TCP_ERROR_RATE TCP_ERROR_RATE_CLIENT TCP_ERROR_RATE_UPSTREAM TCP_CONNECTION_DURATION RESPONSE_RATE ACTIVE_CONNECTIONS NEW_CONNECTION_RATE HTTP_INGRESS_REQUEST_RATE HTTP_EGRESS_REQUEST_RATE
namespace
Namespace

Namespace is used to scope the application traffic to a given namespace.

string
>= 6 characters <= 1024 characters
range
Range

Range decides how far to go back in time to fetch values for each step. For example, if the range is 5m, then for step t1, query will be evaluated for t1-5m and for t2, query will be evaluated for t2-5m and so on. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days

Note: For non-timeseries query, i.e., for step=end_time-start_time, range should be set to end_time-start_time

Optional: If not specified, range is set to 5m.

string
<= 1024 characters
src_id
object
app_type
App Type

Application type associated with the service.

string
<= 1024 characters
service
Service

Network name or name of the virtual service Required: YES.

string
<= 1024 characters
site
Site

Site name where the service is running. If the service is deployed in multiple sites, only the metric from this site will be returned in the response.

string
<= 1024 characters
vip
VIP

VIP associated with the Virtual Host.

string
<= 1024 characters
virtual_host
Virtual Host

Virtual host associated with the service Required: YES.

string
<= 1024 characters
start_time
Start time

Start time of metric collection from which data will be considered to build graph. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the start_time will be evaluated to end_time-10m If end_time is not specified, then the start_time will be evaluated to -10m.

string
<= 1024 characters
step
Step

Step is the resolution width, which determines the number of the data points [x-axis (time)] to be returned in the response. The timestamps in the response will be t1=start_time, t2=t1+step, … Tn=tn-1+step, where tn <= end_time. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days

Optional: If not specified, then step size is evaluated to <end_time - start_time>

string
<= 1024 characters

A successful response.

Media typeapplication/json
Service Edge Response

Response for graph/service/edge API returns the time-series data for the service edge specified in the request.

object
data
object
api_endpoints
API Endpoints

Discovered API Endpoints between two services.

Array<object>
Edge API Endpoint

Details about the discovered API Endpoints between services. Each discovered Endpoint has a collapsed URL and the associated method. Probablity Density Function of request size, response size and latency per API Endpoint is also returned.

object
api_ep
object
access_discovery_time
access_discovery_time

Access_discovery_time is the time when the API endpoint was updated from the access logs by the discovery mechanism. It is the UTC time and represented in RFC3339 form.

string format: date-time
<= 1024 characters
api_groups
API Groups membership

List of API Groups the API Endpoint is a member of.

Array<string>
api_type
string
default: API_TYPE_UNKNOWN
Allowed values: API_TYPE_UNKNOWN API_TYPE_GRAPHQL API_TYPE_REST API_TYPE_GRPC
attributes
attributes

List of API endpoint attributes.

Array<string>
authentication_state
string
default: AUTH_STATE_UNKNOWN
Allowed values: AUTH_STATE_UNKNOWN AUTH_STATE_AUTHENTICATED AUTH_STATE_UNAUTHENTICATED
authentication_types
authentication_types

List of authentication types found in the API endpoint and their locations.

Array<object>
APIEP Authentication Type and Location Pair

API Endpoint’s Authentication Type and Location.

object
auth_type
auth_type

The detected authentication type by string format.

string
<= 1024 characters
location
string
default: AUTH_LOCATION_HEADER
Allowed values: AUTH_LOCATION_HEADER AUTH_LOCATION_QUERY AUTH_LOCATION_BODY AUTH_LOCATION_COOKIE
type
string
default: AUTH_TYPE_BASIC
Allowed values: AUTH_TYPE_BASIC AUTH_TYPE_BEARER AUTH_TYPE_JWT AUTH_TYPE_API_KEY AUTH_TYPE_OAUTH2 AUTH_TYPE_OPENID AUTH_TYPE_HTTP AUTH_TYPE_OAUTH1 AUTH_TYPE_DIGEST AUTH_TYPE_NEGOTIATE
avg_latency
avg_latency

Average latency observed for the API Endpoint.

number format: float
base_path
base_path

The base path for this Endpoint.

string
<= 1024 characters
category
Category

The category of the API Endpoint relative to API Inventory.

Array<string>
Allowed values: APIEP_CATEGORY_DISCOVERED APIEP_CATEGORY_SWAGGER APIEP_CATEGORY_INVENTORY APIEP_CATEGORY_SHADOW APIEP_CATEGORY_DEPRECATED APIEP_CATEGORY_NON_API
collapsed_url
Identified API

URL for automatically identified API.

string
<= 1024 characters
compliances
compliances

List of compliance frameworks of the Endpoint.

Array<string>
domains
List of domains

List of Domains of the API endpoint.

Array<string>
dyn_examples
Expanded URL(s)

For example - {“dyn_examples”: [ { “component_identifier”: “API/v1/user_id/DYN”, “component_examples”: [ “cmenomo007”, “marcusaurelius” “artattacksince1947”, “johndoe83”, ] }, { “component_identifier”: “API/v1/user_id/DYN/vehicle_id/DYN”, “component_examples”: [ “JN1CV6AR3AM458367”, “1GBCS10AXP2917522”, “JM1DE1KY9D0155647”, “JN1CA31D5YT533780” ] } ]} List of sample URL(s) that are collapsed and dynamic components to collapse them.

Array<object>
API endpoint dynamic example

List of Examples of expanded URL components for API endpoints that are collapsed with a dynamic component that is identified automatically.

object
component_examples
List of expanded URLs

List of sample URL(s) that are collapsed.

Array<string>
component_identifier
Dynamic component

Dynamic component used to collapse sample URLs given in Expanded URLs.

string
<= 1024 characters
engines
engines

List of engines that detected the endpoint.

Array<string>
err_rsp_count
error status code count

Number of request with 4xx or 5xx response for the API Endpoint.

string format: uint64
<= 1024 characters
has_learnt_schema
Has Learnt Schema

Has Learnt Schema flag for request API endpoint.

boolean format: boolean
last_tested
last api testing

API testing last tested time is the time when the API endpoint was last tested.

string format: date-time
<= 1024 characters
max_latency
max_latency

Maximum latency observed for the API Endpoint.

number format: float
method
HTTP method

HTTP method for the API.

string
<= 1024 characters
pdf_info
object
creation_timestamp
creation_timestamp

Creation_timestamp represents the time when this PDF was created It is represented in RFC3339 form and is in UTC.

string format: date-time
<= 1024 characters
error_rate
PDF(error rate)

List of Probability density points for PDF for error rate.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
error_rate_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
latency_no_data
PDF(response latency to first byte)

List of Probability density points for PDF for latency of response begin.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
latency_no_data_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
latency_with_data
PDF(response latency)

List of Probability density points for PDF for latency of response end.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
latency_with_data_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
request_rate
PDF(request rate)

List of Probability density points for PDF for request rate.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
request_rate_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
request_size
PDF(request_size)

List of Probability density points for PDF for request size.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
request_size_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
response_size
PDF(response_size)

List of Probability density points for PDF for response size.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
response_size_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
response_throughput
PDF(response throughput)

List of Probability density points for PDF for response throughput.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
response_throughput_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
pii_level
string
default: APIEP_PII_NOT_DETECTED
Allowed values: APIEP_PII_NOT_DETECTED APIEP_PII_DETECTED
req_rate
req_rate

Request rate for the API Endpoint.

number format: float
request_percentage
Request percentage

Percentage of requests that were directed to this API Endpoint.

number format: float
requests_count
requests_count

Number of requests seen for this API Endpoint for the specified time-range.

integer format: int32
risk_score
object
score
score

Score of the vulnerabilities found for this API Endpoint.

number format: float
severity
string
default: APIEP_SEC_RISK_NONE
Allowed values: APIEP_SEC_RISK_NONE APIEP_SEC_RISK_LOW APIEP_SEC_RISK_MED APIEP_SEC_RISK_HIGH APIEP_SEC_RISK_CRITICAL
schema_status
schema_status

Schema status indicates the API Endpoint’s schema origin and if it’s outdated.

string
<= 1024 characters
sec_events_count
sec_events_count

Number of sec_events seen for this API Endpoint for the specified time-range.

integer format: int32
security_risk
string
default: APIEP_SEC_RISK_NONE
Allowed values: APIEP_SEC_RISK_NONE APIEP_SEC_RISK_LOW APIEP_SEC_RISK_MED APIEP_SEC_RISK_HIGH APIEP_SEC_RISK_CRITICAL
sensitive_data
List of Sensitive Data

List of Sensitive Data found in the API endpoint.

Array<string>
Allowed values: SENSITIVE_DATA_TYPE_CCN SENSITIVE_DATA_TYPE_SSN SENSITIVE_DATA_TYPE_IP SENSITIVE_DATA_TYPE_EMAIL SENSITIVE_DATA_TYPE_PHONE SENSITIVE_DATA_TYPE_CREDENTIALS SENSITIVE_DATA_TYPE_APP_INFO_LEAKAGE SENSITIVE_DATA_TYPE_MASKED_PII SENSITIVE_DATA_TYPE_LOCATION
sensitive_data_location
sensitive data location

Sensitive data location for the API Endpoint.

Array<string>
sensitive_data_types
List of Sensitive Data

List of Sensitive Data found in the API endpoint.

Array<string>
owasp_categories
owasp_categories

Categories of the vulnerability as per the OWASP API Top 10.

Array<object>
OWASP Category

Represents a category of vulnerability as defined in the OWASP API Top 10.

object
link_to_owasp
OWASP reference link

Link to the OWASP documentation for this category.

string
<= 1024 characters
name
Category name

The name of the OWASP API security category.

string
>= 6 characters <= 1024 characters
pdf_info
object
creation_timestamp
creation_timestamp

Creation_timestamp represents the time when this PDF was created It is represented in RFC3339 form and is in UTC.

string format: date-time
<= 1024 characters
error_rate
PDF(error rate)

List of Probability density points for PDF for error rate.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
error_rate_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
latency_no_data
PDF(response latency to first byte)

List of Probability density points for PDF for latency of response begin.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
latency_no_data_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
latency_with_data
PDF(response latency)

List of Probability density points for PDF for latency of response end.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
latency_with_data_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
request_rate
PDF(request rate)

List of Probability density points for PDF for request rate.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
request_rate_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
request_size
PDF(request_size)

List of Probability density points for PDF for request size.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
request_size_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
response_size
PDF(response_size)

List of Probability density points for PDF for response size.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
response_size_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
response_throughput
PDF(response throughput)

List of Probability density points for PDF for response throughput.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
response_throughput_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
healthscore
object
data
Data

List of healthscores specified in the request.

Array<object>
Healthscore Type Data

HealthScoreTypeData contains healthscore type and the corresponding value.

object
reason
Reason

A human readable string explaining the reason in case of bad healthscore.

string
>= 27 characters <= 1024 characters
type
string
default: HEALTHSCORE_NONE
Allowed values: HEALTHSCORE_NONE HEALTHSCORE_CONNECTIVITY HEALTHSCORE_PERFORMANCE HEALTHSCORE_SECURITY HEALTHSCORE_RELIABILITY HEALTHSCORE_OVERALL
value
Value

Healthscore value.

Array<object>
>= 3 characters <= 15 characters
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
metric
object
data
Data

List of metric specified in the request for an edge.

Array<object>
Metric Data

MetricData contains the metric type and the corresponding metric value(s)

object
type
string
default: METRIC_TYPE_NONE
Allowed values: METRIC_TYPE_NONE REQUEST_RATE ERROR_RATE RESPONSE_LATENCY REQUEST_THROUGHPUT RESPONSE_THROUGHPUT ERROR_RATE_3XX ERROR_RATE_4XX ERROR_RATE_5XX RESPONSE_LATENCY_PERCENTILE_50 RESPONSE_LATENCY_PERCENTILE_90 RESPONSE_LATENCY_PERCENTILE_99 RESPONSE_DATA_TRANSFER_DURATION CLIENT_RTT SERVER_RTT SERVER_DATA_TRANSFER_TIME APP_LATENCY REQUEST_TO_ORIGIN_RATE HTTP_REQUEST_RATE HTTP_ERROR_RATE HTTP_ERROR_RATE_4XX HTTP_ERROR_RATE_5XX HTTP_RESPONSE_LATENCY HTTP_RESPONSE_LATENCY_PERCENTILE_50 HTTP_RESPONSE_LATENCY_PERCENTILE_90 HTTP_RESPONSE_LATENCY_PERCENTILE_99 HTTP_SERVER_DATA_TRANSFER_TIME HTTP_APP_LATENCY TCP_CONNECTION_RATE TCP_ERROR_RATE TCP_ERROR_RATE_CLIENT TCP_ERROR_RATE_UPSTREAM TCP_CONNECTION_DURATION RESPONSE_RATE ACTIVE_CONNECTIONS NEW_CONNECTION_RATE HTTP_INGRESS_REQUEST_RATE HTTP_EGRESS_REQUEST_RATE
unit
string
default: UNIT_MILLISECONDS
Allowed values: UNIT_MILLISECONDS UNIT_SECONDS UNIT_MINUTES UNIT_HOURS UNIT_DAYS UNIT_BYTES UNIT_KBYTES UNIT_MBYTES UNIT_GBYTES UNIT_TBYTES UNIT_KIBIBYTES UNIT_MIBIBYTES UNIT_GIBIBYTES UNIT_TEBIBYTES UNIT_BITS_PER_SECOND UNIT_BYTES_PER_SECOND UNIT_KBITS_PER_SECOND UNIT_KBYTES_PER_SECOND UNIT_MBITS_PER_SECOND UNIT_MBYTES_PER_SECOND UNIT_CONNECTIONS_PER_SECOND UNIT_ERRORS_PER_SECOND UNIT_PACKETS_PER_SECOND UNIT_REQUESTS_PER_SECOND UNIT_PACKETS UNIT_PERCENTAGE UNIT_COUNT
value
object
anomaly
Anomaly

Number of anomalies for the given time range.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
confidence_lower_bound
Confidence Lower Bound

Lower Bound of the metric value.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
confidence_upper_bound
Confidence Upper Bound

Upper Bound of the metric value.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
healthscore
Healthscore

Healscore of the metric calculated based on the number of anomalies and the value of the anomalies for the time range.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
raw
Raw

List of metric values for a given metric type.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
trend
Trend

Indicates the metric trend.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
step
step

Actual step size used in the response. It could be higher than the requested step due to metric rollups and the query duration. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days.

string
<= 1024 characters
Example
{
"data": {
"api_endpoints": [
{
"api_ep": {
"api_type": "API_TYPE_UNKNOWN",
"authentication_state": "AUTH_STATE_UNKNOWN",
"authentication_types": [
{
"location": "AUTH_LOCATION_HEADER",
"type": "AUTH_TYPE_BASIC"
}
],
"category": [
"APIEP_CATEGORY_DISCOVERED"
],
"pii_level": "APIEP_PII_NOT_DETECTED",
"risk_score": {
"severity": "APIEP_SEC_RISK_NONE"
},
"security_risk": "APIEP_SEC_RISK_NONE",
"sensitive_data": [
"SENSITIVE_DATA_TYPE_CCN"
]
}
}
],
"healthscore": {
"data": [
{
"type": "HEALTHSCORE_NONE",
"value": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
]
}
]
},
"metric": {
"data": [
{
"type": "METRIC_TYPE_NONE",
"unit": "UNIT_MILLISECONDS",
"value": {
"anomaly": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"confidence_lower_bound": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"confidence_upper_bound": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"healthscore": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"raw": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"trend": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
]
}
}
]
}
}
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example